<?php
//Systemwerte 
include "./02include/system_inc.php";  
include $dateipfad."location.config";

// Ermitteln der Mondphase
$ursprung = mktime(18,31,18,12,22,1999); 
$akt_date = time(); 
define('ZYCLUS', floor(29.530588861 * 86400)); 
$mondphase = round(((($akt_date - $ursprung) / ZYCLUS) - floor(($akt_date - $ursprung) / ZYCLUS)) * 100, 0); 

if ($mondphase <= 1 || $mondphase >= 99 ) $phase_text = 'Vollmond'; 
elseif ($mondphase > 1 && $mondphase < 49) $phase_text = 'abnehmender Mond'; 
elseif ($mondphase >= 49 && $mondphase <= 51) $phase_text = 'Neumond'; 
else $phase_text = 'zunehmender Mond'; 

if ($mondphase <= 1 || $mondphase >= 99 ) $phase_sichtbar = 100; 
elseif ($mondphase > 1 && $mondphase < 49) $phase_sichtbar = ($mondphase-50)*-2; 
elseif ($mondphase >= 49 && $mondphase <= 51) $phase_sichtbar = 0; 
else $phase_sichtbar = ($mondphase - 50)*2; 

// Ermitteln Dämmerungsdaten
//$sun_info = date_sun_info(time(), 54.7111, 8.4069);
$sun_info = date_sun_info(time(), $breitengrad, $laengengrad);

//Tabellenzeile anlegen

echo "<table style=\"padding-right:10px\"><tbody>";
	echo "<tr><td width=\"250px\">Sonnenaufgang</td><td style=\"text-align:right\">".date("H:i", $sun_info['sunrise'])."</td></tr>\n";
	echo "<tr><td>Sonnenuntergang</td><td style=\"text-align:right\">".date("H:i", $sun_info['sunset'])."</td></tr>\n";
	echo "<tr><td>Mondphase (ca. ".$phase_sichtbar." % illuminiert)</td><td style=\"text-align:right\">".$phase_text." </td></tr>\n";
	$JahrBegin = date("Y", $sun_info['astronomical_twilight_begin']);
	if ($JahrBegin == '1970') { echo "<tr><td>astronomische Morgendämmerung</td><td style=\"text-align:right\">keine astronomische D&auml;mmerung</td></tr>\n"; }
		else {echo "<tr><td>astronomische Morgendämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['astronomical_twilight_begin'])."</td></tr>\n";}
	$JahrBegin = date("Y", $sun_info['nautical_twilight_begin']);
	if ($JahrBegin == '1970') { echo "<tr><td>H</td><td style=\"text-align:right\">keine nautische D&auml;mmerung</td></tr>\n"; }
		else {echo "<tr><td>nautische Morgendämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['nautical_twilight_begin'])."</td></tr>\n";}
	echo "<tr><td>bürgerliche Morgendämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['civil_twilight_begin'])."</td></tr>\n";
	echo "<tr><td>Mittag - Zenit Transit</td><td style=\"text-align:right\">".date("H:i", $sun_info['transit'])."</td></tr>\n";
	echo "<tr><td>bürgerliche Abenddämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['civil_twilight_end'])."</td></tr>\n";
	$JahrEnde = date("Y", $sun_info['nautical_twilight_end']);
	if ($JahrEnde == '1970') { echo "<tr><td>nautische Abenddämmerung</td><td style=\"text-align:right\">keine nautische D&auml;mmerung</td></tr>\n"; }
		else {echo "<tr><td>nautische Abenddämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['nautical_twilight_end'])."</td></tr>\n";}   
	$JahrEnde = date("Y", $sun_info['astronomical_twilight_end']);
	if ($JahrEnde == '1970') { echo "<tr><td>astronomische Abenddämmerung</td><td style=\"text-align:right\">keine astronomische D&auml;mmerung</td></tr>\n"; }
		else {echo "<tr><td>astronomische Abenddämmerung</td><td style=\"text-align:right\">".date("H:i", $sun_info['astronomical_twilight_end'])."</td></tr>\n";}
	echo "<tr><td>Am Standort</td><td style=\"text-align:right\">$aktuellerStandort, $breitengrad, $laengengrad</td></tr>\n";   
echo "</tbody></table>";

?>

   