<?php
// ----------------------------------------------------------------------------------------------------
// Ein Overlay in die Bilder einfügen
// ----------------------------------------------------------------------------------------------------

function makeOverlay($inDateiname, $InText)
{

include "./02include/system_inc.php"; 
include "./03config/overlay.config"; 

if ($overlayAktiv == true) {

    // Bildparameter lesen
    list($origWidth, $origHeight, $type) = getimagesize($inDateiname);

    // Exif Daten lesen und als 2 Strings für Ausgabe aufbereiten
    if ($showExif == true) {
    
        // EXIF Daten lesen
        $exiffile = $inDateiname;
        $ifd0 = @exif_read_data($exiffile ,'IFD0' ,0);
        $exif = @exif_read_data($exiffile ,'EXIF' ,0);

        // Aufnahmezeitpunkt
        $shottime = $ifd0['DateTime'];
        $tag = substr($shottime,8,2);
        $monat = substr($shottime,5,2);
        $jahr = substr($shottime,0,4);
        $zeit = substr($shottime,11,8);
        $shottime = "$tag.$monat.$jahr $zeit";

        //Kameramodell
        $modell = $ifd0['Model'];

        //Belichtungszeit
        $belichtungszeit = $ifd0['ExposureTime'];
        $belichtungszeit_raw = $belichtungszeit;
        //$belichtungszeit = str_replace("/1", "", $ifd0['ExposureTime']);
        $belichtungszeit = $belichtungszeit." sec";

        //Blende
        $blende = $ifd0['COMPUTED']['ApertureFNumber'];

        //Brennweite
        $brennweite = $ifd0['FocalLength'];
        $brennweite = str_replace("/1", " mm", $brennweite);
        //if ($brennweite == '18/1') { $brennweite='18 mm'; }

        //ISO-Wert
        $iso = $exif['ISOSpeedRatings'];

        // Objektiv - fest verbaut Wenn Aufnahme von ALLSKY
        $objektiv = "EF-S18-55mm f/3.5-5.6";
        // Objektiv bei Canon EOS 1200D funktionierts
        $objektiv = $ifd0['UndefinedTag:0xA434'];

        // Daten als Textzeile 1 und 2 aufbereiten
        $ExifLine1 = "Bild aufgenommen: $shottime - Kamera: $modell - Objektiv: $objektiv";
        $ExifLine2 = "Brennweite: $brennweite Belichtung: $belichtungszeit Blende: $blende ISO: $iso";

        // ENDE EXIF Daten lesen
    }

    // Freitext aufbereiten
    if ($FreitextAktiv == true) {
        if ($FTOneLine == true) { $printtext1 = $InText." - ".$Freitext; $printtext2 = "";} else { $printtext1 = $InText; $printtext2 = $Freitext; }; 
    }
    else {
        $printtext1 = $InText; 
        $printtext2 = "";
    }

    // Wurde ein Bild erstellt - erstmal nein ?
    $ImageOK = false;
    
    // Erzeugen des Image je nach Typ für weiterre Verarbeitung
    switch ($type) {
        case '1':
            if (($image = imagecreatefromgif($inDateiname)) == true) {  $ImageOK = true;  }
            break;
        case '2':
            if (($image = imagecreatefromjpeg($inDateiname)) == true) {  $ImageOK = true;  }
            break;
        case '3':
            if (($image = imagecreatefrompng($inDateiname)) == true) {  $ImageOK = true;  }
            break;
        default:
            if (($image = imagecreatefromwbmp($inDateiname)) == true) {  $ImageOK = true;  }
    }

    // Eigentliche Verarbeitung des Bildes

    // EXIF Daten ausgeben, wenn gemünscht, diese sind sonst aus dem original Bild gelöscht
    $MoveText = 0;
    
    if ($showExif == true) {
    
    // Zeichen eine gefüllte Box in der gewünschten Hintergrundfarbe ins Bild - Bündig an obere Bildseite
    $hintergrundfarbe = ImageColorAllocate ($image,  $EXHfarbeRED, $EXHfarbeGREEN, $EXHfarbeBLUE);
    $EXIFBoxHigh = (4*$EXpadd) + (2*$EXfsize);
    imagefilledrectangle($image, 0, $EXpadd, $origWidth, $EXIFBoxHigh, $hintergrundfarbe);
    // Textzeilen in die Box ausgeben
    $Textfarbe = ImageColorAllocate ($image,  $EXfarbeRED, $EXfarbeGREEN, $EXfarbeBLUE);
    $topL1 = 2*$EXpadd + $EXfsize;
    $topL2 = 2*$EXfsize + 3*$EXpadd;
    imagettftext($image, $EXfsize, 0, $EXpadd, $topL1, $Textfarbe, $wwwpfad."02include/arial.ttf", $ExifLine1);
    imagettftext($image, $EXfsize, 0, $EXpadd, $topL2, $Textfarbe, $wwwpfad."02include/arial.ttf", $ExifLine2);    

    // der Normaltext und der Freitext müssen um die Höhe der Box verschoben werden
    $MoveText = $EXIFBoxHigh + (3*$EXpadd);

    }
     
    $farbe = imagecolorallocate($image, $farbeRED, $farbeGREEN, $farbeBLUE);
    imagettftext($image, $fsize, $frotation, $posx, $posy+$MoveText, $farbe, $wwwpfad."02include/arial.ttf", $printtext1);
    $FTfarbe = imagecolorallocate($image, $FTfarbeRED, $FTfarbeGREEN, $FTfarbeBLUE);
    imagettftext($image, $FTfsize, $FTfrotation, $FTposx, $FTposy+$MoveText, $FTfarbe, $wwwpfad."02include/arial.ttf", $printtext2);

    // Bild wieder je nach Typ speichern
    switch ($type) {
        case '1':
            imagegif($image, $inDateiname);
            break;
        case '2':
            imagejpeg($image, $inDateiname);
            break;
        case '3':
            imagepng($image, $inDateiname);
            break;
        default:
                imagewbmp($image, $inDateiname);
    }

    // Bild löschen
    imagedestroy($image);
    
}

}

// ----------------------------------------------------------------------------------------------------
// Einen Log Eintrag in eine Datei hinzufügen
// ----------------------------------------------------------------------------------------------------

// Protokoll anlegen und Speichern
function writeLog($datei, $text)
{
$logtext = date("d.m.Y - H:i:s", time())." ".$text."\n";
file_put_contents($datei, $logtext, FILE_APPEND);
}

// ----------------------------------------------------------------------------------------------------
// Ermitteln der aktuellen Belichtungszeit, Rückgabewerte als Text und als Sekundenwert zum Rechnen
// in einem Array
// ----------------------------------------------------------------------------------------------------
function getCurrentShutterspeed()
{
$shellcmd = "gphoto2 --get-config shutterspeed";
$ergebnis=null; $retval=null;
exec($shellcmd, $ergebnis, $retval);
$ausgabe = array();
$ShutterspeedText = trim(substr($ergebnis[3], 9));
$posi = strpos($ShutterspeedText,"/");
if ($posi == true) { 
  $zaehler = substr($ShutterspeedText,0, $posi); 
  $nenner = substr($ShutterspeedText, $posi+ 1);
  $ausgabe["text"] = $ShutterspeedText;
  $ausgabe["wert"] = $zaehler/$nenner;
  }
  else {
    $ausgabe["text"] = $ShutterspeedText;
    $ausgabe["wert"] = floatval($ShutterspeedText);
  }
  if ( substr($ausgabe["text"], 0, 7) == "mailing" ) { $ausgabe["text"] = 'keine Kamera vorhanden'; $ausgabe['wert'] = 0; }
  
  return $ausgabe;
}

// ----------------------------------------------------------------------------------------------------
// In Kameramatrix prüfen, welche Parameter wie angesprochen werden können
// Prüfung je Kamera und Parameter (z.B. ISO)
// Leerzeichen im Kameranamen, wie er von der Kamera ausgegeben wurde, werden ersetzt durch "_" da sonst der Array Zugriff nicht funktioniert
// Funktion liefert   0 = nicht verfügbar, 1=verfügbar für lesen&schreiben, 2=verfügbar Readonly
// Wenn eine Kamera nicht in der Matrix steht, wird der STANDARD angenommen
// ----------------------------------------------------------------------------------------------------
function getMatrixConfig($InKameraname, $InPropertie)
{
//Starcatcher Kameramatrix
include "./03config/kameramatrix.config"; 

$action = "";

if (array_key_exists($InPropertie, $KameraProperties[$InKameraname])) {
    // Zuweisen des Elements bei Index '$InPropertie' (z.B. iso) an die Variable $action
  [$InPropertie => $action] = $KameraProperties[$InKameraname];
  }
else { [$InPropertie => $action] = $KameraProperties["STANDARD"]; };

// echo 'Wert '.$InPropertie." - ".$action." - ".array_key_exists($InPropertie, $KameraProperties[$InKameraname]).' <--<br>';
return $action;

}


// ----------------------------------------------------------------------------------------------------
// Parameter der angeforderten Konfiguration auf Kamera setzen
// ----------------------------------------------------------------------------------------------------
function setConfig($InKameraname, $parameter, $value)
{
//Starcatcher Konfiguration
include "./03config/starcatcher.config"; 

// Einstellungen auf der Kamera dürfen nur gemacht werden, wenn der angeforderte Parameter 
// nicht ReadOnly ist oder gar nicht verwendet werden kann (laut Kameramatrix)

$Matrixwert = getMatrixConfig($InKameraname, $parameter);
// echo "Wert: ".$Matrixwert."<br>"; 

if ($Matrixwert == "1") {
if ($parameter == "datetime") { $shellcmd = "gphoto2 --set-config ".trim($parameter)."=".trim($value); }
    else {$shellcmd = "gphoto2 --set-config-index ".trim($parameter)."=".trim($value);}

$ergebnis=null; $retval=null;
exec($shellcmd, $ergebnis, $retval);
if ($DSPplanparameter==true) {
  if ($retval==0) { echo "Kameraparamter: $parameter eingestellt auf Auswahl $value<br>"; } 
  else {  echo "Kameraparamter: $parameter nicht eingestellt Fehler !<br>"; }
}
}
}

// ----------------------------------------------------------------------------------------------------
// Parameter der angeforderten Konfiguration lesen und ein Eingabe Element für Parameter erstellen
// ----------------------------------------------------------------------------------------------------
function makeConfig($InKameraname, $parameter)
{

//Starcatcher Konfiguration
include "./03config/starcatcher.config"; 

$shellcmd = "env LANG=de_DE.UTF-8 gphoto2 --get-config ".trim($parameter);
$ergebnis=null; $retval=null;
exec($shellcmd, $ergebnis, $retval);
//echo "gelesener Kameraparamter: $parameter (Returned with status $retval)<br><br>";

// Hinweis ausgeben, ob Parameter Read Only
// Funktion liefert   0 = nicht verfügbar, 1=verfügbar für lesen&schreiben, 2=verfügbar Readonly

if (getMatrixConfig($InKameraname, $parameter) == "0")  { echo "<div class=\"SystemCode\">/** GPHOTO2-Parameter: ".$parameter." für Kamera nicht verfügbar!</div><br>";   }

else 

{  
// Unterscheiden, welche Art von Parameter gelesen wurde

switch (trim($ergebnis[2])) {
    case 'Type: TEXT':
        //LABEL & CURRENT wegschneiden
        $labelohnec = trim(substr($ergebnis[0], 7)); 
        $textohnec = trim(substr($ergebnis[3], 9));
        echo $labelohnec." : ".$textohnec."<br>";
        break;
    case 'Type: DATE':
        //LABEL & CURRENT wegschneiden
        $labelohnec = trim(substr($ergebnis[0], 7)); 
        $textohnec = trim(substr($ergebnis[4], 11));
        echo $labelohnec." : ".$textohnec."<br>";
        break;
    case 'Type: RADIO':
        $BulbDetected = false; 
        echo "<label for=\"$parameter\">".trim(substr($ergebnis[0], 7))."</label><br>";
        if (getMatrixConfig($InKameraname, $parameter) == "2")  { echo "<div class=\"SystemCode\">/** GPHOTO2-Parameter: ".$parameter." für Kamera nur ReadOnly. <br>Keine Änderung durch die Software.</div>";  }
        // ermitteln aktuell eingestellten Wert der Kamera
        $selectedvalue = trim(substr($ergebnis[3], 9));
        echo "<select id=\"$parameter\" name=\"$parameter\">";
        for($i = 4; $i < count($ergebnis)-1; $i++) {
          // CHOICE wegschneiden
          $textwoc = trim(substr($ergebnis[$i], 8));
          // Position Leerzeichen ermitteln
          $posblank = strpos($textwoc," ");
          $value = " "; $value = trim(substr($textwoc, 0, $posblank));
          $valuetext = " "; $valuetext = trim(substr($textwoc, $posblank));
          if ($valuetext == "bulb" or $valuetext == "Bulb" or $valuetext == "Langzeitbelichtung") { $BulbDetected = true; }
          if($valuetext == $selectedvalue) {
            echo "<option value=\"".$value."\" selected>".$valuetext."&nbsp;&nbsp;&nbsp;&nbsp;(".$value.")</option>\n";  
          }
          else {
            echo "<option value=\"".$value."\">".$valuetext."&nbsp;&nbsp;&nbsp;&nbsp;(".$value.")</option>\n";  
          }
        }
        echo "</select><br>";

        // Es wurde die Auswahl Bulb entdeckt, als ein Eingabefeld für Langzeitsekunden bereitstellen.
        if ($BulbDetected == true) {  
          echo "<br><label for=\"pause\">Sekunden für Bulb Belichtungen</label><br>";
          echo "<input style=\"width:200px\" id=\"bulb\" name=\"bulb\" type=\"number\" min=\"1\" max=\"".$maxbulb."\" step=\"1\" value=\"".$usebulb."\"><br>";
        }

        break;
// End of Switch
}
// End of else getMatrixConfig
}

}

// rec_rmdir - loesche ein Verzeichnis rekursiv
// Rueckgabewerte:
//   -0 - alles ok
//   -1 - kein Verzeichnis
//   -2 - Fehler beim Loeschen
//   -3 - Ein Eintrag eines Verzeichnisses war keine Datei und kein Verzeichnis und
//        kein Link
function rec_rmdir ($path) {
  // schau' nach, ob das ueberhaupt ein Verzeichnis ist
  if (!is_dir ($path)) {
      return -1;
  }
  // oeffne das Verzeichnis
  $dir = @opendir ($path);
  
  // Fehler?
  if (!$dir) {
      return -2;
  }
  
  // gehe durch das Verzeichnis
  while ($entry = @readdir($dir)) {
      // wenn der Eintrag das aktuelle Verzeichnis oder das Elternverzeichnis
      // ist, ignoriere es
      if ($entry == '.' || $entry == '..') continue;
      // wenn der Eintrag ein Verzeichnis ist, dann 
      if (is_dir ($path.'/'.$entry)) {
          // rufe mich selbst auf
          $res = rec_rmdir ($path.'/'.$entry);
          // wenn ein Fehler aufgetreten ist
          if ($res == -1) { // dies duerfte gar nicht passieren
              @closedir ($dir); // Verzeichnis schliessen
              return -2; // normalen Fehler melden
          } else if ($res == -2) { // Fehler?
              @closedir ($dir); // Verzeichnis schliessen
              return -2; // Fehler weitergeben
          } else if ($res == -3) { // nicht unterstuetzer Dateityp?
              @closedir ($dir); // Verzeichnis schliessen
              return -3; // Fehler weitergeben
          } else if ($res != 0) { // das duerfe auch nicht passieren...
              @closedir ($dir); // Verzeichnis schliessen
              return -2; // Fehler zurueck
          }
      } else if (is_file ($path.'/'.$entry) || is_link ($path.'/'.$entry)) {
          // ansonsten loesche diese Datei / diesen Link
          $res = @unlink ($path.'/'.$entry);
          // Fehler?
          if (!$res) {
              @closedir ($dir); // Verzeichnis schliessen
              return -2; // melde ihn
          }
      } else {
          // ein nicht unterstuetzer Dateityp
          @closedir ($dir); // Verzeichnis schliessen
          return -3; // tut mir schrecklich leid...
      }
  }
  
  // schliesse nun das Verzeichnis
  @closedir ($dir);
  
  // versuche nun, das Verzeichnis zu loeschen
  $res = @rmdir ($path);
  
  // gab's einen Fehler?
  if (!$res) {
      return -2; // melde ihn
  }
  
  // alles ok
  return 0;
}


/**  Resize image - preserve ratio of width and height.
 * @param string $sourceImage path to source JPEG image
 * @param string $targetImage path to final JPEG image file
 * @param int $maxWidth maximum width of final image (value 0 - width is optional)
 * @param int $maxHeight maximum height of final image (value 0 - height is optional)
 * @param int $quality quality of final image (0-100)
 * @return bool
 * 
 * Example   resizeImage('image.jpg', 'resized.jpg', 200, 200);
 */
 
 function resizeImage($sourceImage, $targetImage, $maxWidth, $maxHeight, $quality)
 {
 list($origWidth, $origHeight, $type) = getimagesize($sourceImage);
 
 if ($type == 1)
 {   header ('Content-Type: image/gif');
     $image = imagecreatefromgif($sourceImage);
 }
 elseif ($type == 2)
 {   header ('Content-Type: image/jpeg');
     $image = imagecreatefromjpeg($sourceImage);
 }
 elseif ($type == 3)
 {   header ('Content-Type: image/png');
     $image = imagecreatefrompng($sourceImage);
 }
 else
 {   header ('Content-Type: image/x-ms-bmp');
     $image = imagecreatefromwbmp($sourceImage);
 }
 
 if ($maxWidth == 0)  {  $maxWidth  = $origWidth;  } 
 if ($maxHeight == 0) {  $maxHeight = $origHeight; }
 
 // Calculate ratio of desired maximum sizes and original sizes.
 $widthRatio = $maxWidth / $origWidth;
 $heightRatio = $maxHeight / $origHeight;
 
 // Ratio used for calculating new image dimensions.
 $ratio = min($widthRatio, $heightRatio);
 
 // Calculate new image dimensions.
 $newWidth  = (int)$origWidth  * $ratio;
 $newHeight = (int)$origHeight * $ratio;
 
 // Create final image with new dimensions.
 
 // if($type==1 or $type==3)
 // {   $newImage = imagefill($newImage,0,0,0x7fff0000); }
 
 $newImage = imagecreatetruecolor($newWidth, $newHeight);
 
 $transparent = imagecolorallocatealpha($newImage, 0, 0, 0, 127);
 imagefill($newImage, 0, 0, $transparent);
 imagesavealpha($newImage, true);
  
 imagecopyresampled($newImage, $image, 0, 0, 0, 0, $newWidth, $newHeight, $origWidth, $origHeight);
 imagepng($newImage, $targetImage);
 
 // Free up the memory.
 imagedestroy($image);
 imagedestroy($newImage);
 
 return true;
 }