#!/usr/bin/python3
# -*- coding: utf-8 -*-

# eventuell vorher ausführen

# sudo apt-get update && sudo apt-get upgrade -y

# Der Befehl installiert die python2-pip-Anwendung. Wird verwendet diese um die Library zu installieren:
# sudo apt-get install python3-pip

# Der Befehl installiert andere Anwendungen, die die pip-App für die Installation der Library benötigt:
# sudo python3 -m pip install --upgrade pip setuptools wheel

# Danach können wir die notwendige Library installieren. Führen Sie folgenden Befehl aus:
# sudo pip3 install Adafruit_adt7410

# Nun kann man die Adafruit_adt7410 in Python Programmen verwendet werden

import time
import board
import adafruit_adt7410

i2c = board.I2C()  # uses board.SCL and board.SDA
adt = adafruit_adt7410.ADT7410(i2c, address=0x48)
adt.high_resolution = True

if adt.temperature:
  print(adt.temperature)
else :
  print("# -273K - Fehler - Sensorwertermittlung!")
