#!/usr/bin/python
# -*- coding: utf-8 -*-

# eventuell vorher ausführen

# sudo apt-get update && sudo apt-get upgrade -y

# Der Befehl installiert die python2-pip-Anwendung. Wird verwendet diese um die Library zu installieren:
# sudo apt-get install python3-pip

# Der Befehl installiert andere Anwendungen, die die pip-App für die Installation der Library benötigt:
# sudo python3 -m pip install --upgrade pip setuptools wheel

# Danach können wir die notwendige Library installieren. Führen Sie folgenden Befehl aus:
# sudo pip3 install Adafruit_DHT

# Nun kann man die Asafruit_DHT in Python Programmen verwendet werden

import sys
import Adafruit_DHT

# Parse command line parameters.
sensor_args = { '11': Adafruit_DHT.DHT11,
                '22': Adafruit_DHT.DHT22,
                '2302': Adafruit_DHT.AM2302 }
if len(sys.argv) == 3 and sys.argv[1] in sensor_args:
    sensor = sensor_args[sys.argv[1]]
    pin = sys.argv[2]
else:
    print('Usage: sudo ./Adafruit_DHT.py [11|22|2302] <GPIO pin number>')
    print('Example: sudo ./Adafruit_DHT.py 2302 4 - Read from an AM2302 connected to GPIO pin #4')
    sys.exit(1)

# Sensor auslesen - Use the read_retry method which will retry up to 15 times to get a sensor reading (waiting 2 seconds between each retry).
humidity, temperature = Adafruit_DHT.read_retry(sensor, pin)

# Note that sometimes you won't get a reading and the results will be null (because Linux can't guarantee the timing of calls to read the sensor). If this happens try again!
if humidity is not None and temperature is not None:
# Un-comment the line below to convert the temperature to Fahrenheit.
# temperature = temperature * 9/5.0 + 32
#    print('Temp={0:0.1f}*  Humidity={1:0.1f}%'.format(temperature, humidity))
    print('{0:0.1f}'.format(temperature))
else:
    print("# -273K - Fehler - DHT22 Temperatur Sensorwertermittlung!")
    sys.exit(1)
