<?php

// Layout laden
// Layotanpassungen können durch überschreiben der Variablen aus mainlayout_inc.php vorgenommen werden 
include "./02include/mainlayout_inc.php";  
include "./03config/sensoren.config";

// Überschreibungen
$titel2="Sensoren am Server";
$refreshTime = $SensorenInterval;

include "./02include/htmlmain_inc.php";  
include "./02include/kopf_inc.php";
include "./02include/myRaspiToolbox.php";

$Durchnittstemperatur = 0;
$AnzahlTemperaturwerte = 0;

echo "<div class=\"mainbox\">\n";

// ===========================================================
// Inhalt der Seite 
// Ab hier reines HTML - PHP bei Bedarf ein und auschalten
// ===========================================================
?>
<br>
<?php
echo "<h2>$titel2</h2>";

echo "<table border=\"0\"><tbody>";
// Leerzeile
echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 	

if ($SensorenAktiv == true) {

	// alle W1 Sensoren auslesen
	if ($W1Sensoren == true) {
		echo "<tr><td colspan=\"3\"><h4>automatische Sensorermittlung</h4></td></tr>\n"; 	
		$Sensorliste = array();
		$Sensorliste = getSensoren();
		foreach ($Sensorliste as $sensor) {
			$Typ = $sensor['SensorTyp'];
			$SFile = $sensor['SensorFile'];
			$Temperatur = getTemperatur($SFile, $Typ ) ;
			$AnzahlTemperaturwerte = $AnzahlTemperaturwerte + 1; 
			$Durchnittstemperatur = $Durchnittstemperatur + $Temperatur;
				echo "<tr><td width=\"25%\">Temperatur W1 DS18B20 Sensor:</td><td width=\"30%\">$Temperatur&deg;C</td><td>Sensor($Typ): $SFile</td></tr>\n"; 	
				echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 			
			}
		// Ende alle W1 Sensoren auslesen
	}

	// Einen angegebenen Sensor auslesen
	if ($DS18B20 > '') {
		echo "<tr><td colspan=\"3\"><h4>spezifizierter Sensor</h4></td></tr>\n"; 	
		$Temperatur = getTemperatur($DS18B20, $W1SensorenTyp ) ;
		$AnzahlTemperaturwerte = $AnzahlTemperaturwerte + 1; 
		$Durchnittstemperatur = $Durchnittstemperatur + $Temperatur;
		echo "<tr><td width=\"25%\">Temperatur W1 DS18B20 Sensor:</td><td width=\"30%\">$Temperatur&deg;C</td><td>Sensor($W1SensorenTyp): $DS18B20</td></tr>\n"; 	
		echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 			
	}
		
	// einen ADT7410 Sensor verarbeitenn
	if ($ADT7410Sensor == true) {
		$Temperatur = getTemperaturADT7410();
		$AnzahlTemperaturwerte = $AnzahlTemperaturwerte + 1; 
		$Durchnittstemperatur = $Durchnittstemperatur + $Temperatur;
		echo "<tr><td colspan=\"3\"><h4>ADT7410 Sensor auslesen</h4></td></tr>\n"; 	
		echo "<tr><td width=\"25%\">Temperatur ADT7410 Sensor:</td><td width=\"30%\">$Temperatur&deg;C</td><td>Sensor: ADT7410 I2C Bus</td></tr>\n"; 	
		echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 			
	}
	
	// einen DHT22 Temperatur und Feuchtigkeits Sensor verarbeitenn
	if ($DHT22Sensor == true) {
		$Temperatur = getTemperaturDHT22();
		$AnzahlTemperaturwerte = $AnzahlTemperaturwerte + 1; 
		$Durchnittstemperatur = $Durchnittstemperatur + $Temperatur;
		echo "<tr><td colspan=\"3\"><h4>DHT22 Sensor auslesen</h4></td></tr>\n"; 	
		echo "<tr><td width=\"25%\">Temperatur DHT22 Sensor:</td><td width=\"30%\">$Temperatur&deg;C</td><td>Sensor: DHT22</td></tr>\n"; 	
		echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 			
		$Feuchtigkeit = getFeuchtigkeitDHT22();
		echo "<tr><td width=\"25%\">Feuchtigkeit DHT22 Sensor:</td><td width=\"30%\">$Feuchtigkeit</td><td>Sensor: DHT22</td></tr>\n"; 	
		echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 			

	}
// Ende alle W1 Sensoren auslesen


	// Durchsnittstemperatur ausgeben

	$Durchnittstemperatur = $Durchnittstemperatur/$AnzahlTemperaturwerte;
	echo "<tr><td colspan=\"3\"><h4>Durchschnittstemperatur aller Sensoren</h4></td></tr>\n"; 	
	echo "<tr><td width=\"25%\">Mittelwert der Sensoren:</td><td width=\"30%\">".round($Durchnittstemperatur,2)."&deg;C</td><td>Anzahl Messwerte: $AnzahlTemperaturwerte</td></tr>\n"; 	
	echo "<tr><td colspan=\"3\">&nbsp;</td></tr>\n"; 		
}

else

{
echo "<tr><td colspan=\"3\">Sensoren auf diesem System nicht aktiviert. Wenn Sensoren an diesem System angeschlossen sind, k&ouml;nnen diese &uuml;ber die Konfiguration aktiviert werden.</td></tr>\n"; 	
}

echo "</tbody></table>";

// ===========================================================
// Ende Inhalt der Seite
// ===========================================================
echo "</div>\n";

// Fusszeile 
if ($dspfuss == true) { echo "<div class=\"spruchbox\" style=\"color:#FFFFFF\">$Spruch</div>\n"; }
if ($dspfuss == true) { echo "<div class=\"copyrightbox\">$fusstext</div>\n"; }

echo "</body>\n";
echo "</html>\n";
?>

