<?php

// ----------------------------------------------------------------------------------------------------
// Dieser Job wird gestartet, wenn ein Video aus den Dateien in einm Verzeichnis erstellt werden soll
// Das Video wird mit FFMPEG erstellt diese muss vorher inklusive libx264 Support installiert sein
// ----------------------------------------------------------------------------------------------------

$myPfad01="/var/www/html/StarCatcher/02include";
$myPfad02="/var/www/html/StarCatcher/03config";
$myPfad03="/var/www/html/StarCatcher/";
set_include_path($myPfad01 . PATH_SEPARATOR . $myPfad02. PATH_SEPARATOR . $myPfad03);
/* $weg=get_include_path(); echo "Hallo:".$weg; */  

// Errorhandling - kann bei Bedarf aktiviert werden 
// include "errorhandling_inc.php"; 
// Systemwerte 
include "system_inc.php"; 
// Starcatcher Konfiguration
include "starcatcher.config";   
// My Functions
include "myfunctions_inc.php";   


// ----------------------------------------------------------------------------------------------------
// Verarbeitung
// ----------------------------------------------------------------------------------------------------

// Dieser Job kann lange dauern, daher muss das Time Limit für die Ausführung von PHP Scripten erhöht werden (Std 30 Sec)
ini_set('max_execution_time', '10800'); //10800 seconds = 3 Stunde

// Parameter lesen, wenn nicht alle Angaben enthalten, dann Abbruch
$abbruch = false;

// Logfile festlegen , falls keine Name mit verzeichnis gebildet werden kann
$logTemp = date("Ymd_His"); 
$logfile = $StarCatcherLogDir.$logTemp."_CreateVideo.log";

// Parameterdatei für Übergabe der Variablen
$parameterdatei = "video.runtime.php";

// Laden der Parameterdatei mit den Parametern für das Video - wenn nicht gefunden, Abbruch
if ((include $parameterdatei) == TRUE) { 
    // Paramter gefunden, ins Protokoll schreiben und aufbreiten
    // Logfile festlegen
    $logfile = $StarCatcherLogDir.$BildDIR."_CreateVideo.log";
    $logtext = "________ Start neuer Programmaufruf _________________________________________";  writeLog($logfile, $logtext); 
    $logtext = "Videoerstellung - Programm gestartet";  writeLog($logfile, $logtext); 
    $logtext = "Bilderverzeichnis Quelle: $BildDIR";    writeLog($logfile, $logtext);
    // Bildsource festlegen
    $BildSRC = $StarCatcherPictureDir.$BildDIR."/"; 
    $logtext = "BildSource: $BildSRC";  writeLog($logfile, $logtext); 
    if (!is_dir("$BildSRC")) { 
        $abbruch = true;
        $logtext = "Bildquelle $BildSRC existiert nicht";  writeLog($logfile, $logtext); 
        }
    $logtext = "Video Breite: $VideoBreite";            writeLog($logfile, $logtext); 
    $logtext = "Video Höhe: $VideoHoehe";               writeLog($logfile, $logtext); 
    $logtext = "Video Frequenz: $hz";                   writeLog($logfile, $logtext); 
    // Breite und Höhe des gewünschten Videos dürfen die maximale Auflösung nicht überschreiten oder kleiner 0 sein
    if (($VideoBreite > $MaxResolutionX) or ($VideoBreite < 0)) { $abbruch = true; $logtext = "Videobreite überschreitet maximal zulässigen Wert oder ist kleiner 0 ($MaxResolutionX): $VideoBreite";   writeLog($logfile, $logtext);  }
    // Breite und Höhe des gewünschten Videos dürfen die maximale Auflösung nicht überschreiten oder kleiner 0 sein
    if (($VideoHoehe > $MaxResolutionY) or ($VideoHoehe < 0)) { $abbruch = true; $logtext = "Videohöhe überschreitet maximal zulässigen Wert oder ist kleiner 0  ($MaxResolutionY): $VideoHoehe";   writeLog($logfile, $logtext);  }
}
else {
    $abbruch = true; 
}

   
// Starten der Verarbeitung
if ($abbruch == false) { 

  
    // Bilder im Source Verzeichnis in ein Array lesen
    $Quelldateien = array_diff(scandir($BildSRC), array('..', '.'));

    // Etwas Kalkulation der neuen Bildgröße
    // libx264 mit ffmpeg hat eine maximale Auflösung für videos von 4096 x 2304 
    $MaxRatio = $MaxResolutionX/$MaxResolutionY;
    $logtext = "Seitenverhältnis der Video Obergrenze: $MaxRatio";    writeLog($logfile, $logtext); 

    // Seitenverhältnis des gewünschten Zielvideos
    $ZielRatio = $VideoBreite/$VideoHoehe; 
    $logtext = "Seitenverhältnis des Zielvideos: $ZielRatio";    writeLog($logfile, $logtext); 

    // Seitenverhältnis eines Orignal Bildes 
    // Arry Index 3, da index erst bei 3 beginnt, weil . .. und Video_Temp ausgeschlossen wurden
    $bild = $BildSRC.$Quelldateien[2];
    list($origWidth, $origHeight, $type) = getimagesize($bild);
 
    $logtext = "orignal Breite der Aufnahmen: $origWidth";    writeLog($logfile, $logtext); 
    $logtext = "orignal Höhe der Aufnahmen: $origHeight";    writeLog($logfile, $logtext); 
 
    $OrgRatio = $origWidth/$origHeight; 
    $logtext = "Seitenverhältnis der original Bilder: $OrgRatio";    writeLog($logfile, $logtext); 

    // Wenn das Seitenverhältnis der Original Bilder abweichend vom Sietenverhältnis des gewünschten Videos ist,
    // dann wird das Seitenverhältnis des gewünschten Videos angepaßt.

    if (!($OrgRatio == $ZielRatio)) {
        $logtext = "Seitenverhältnis der original Bilder ($OrgRatio) weicht vom gewünschten Seitenverhältnis des Zielvideos ($ZielRatio) ab.";        writeLog($logfile, $logtext); 
        $logtext = "Videoformat wird auf Basis der längeren Seite angepaßt.";        writeLog($logfile, $logtext); 
        if ($VideoBreite>$VideoHoehe) 
            { $VideoHoehe = round($VideoBreite/$OrgRatio); $logtext = "Videohöhe auf $VideoHoehe angepasst (Seitenverhältnis: $OrgRatio)"; writeLog($logfile, $logtext);  }  
        else 
            { $VideoBreite = round($VideoHoehe*$OrgRatio); $logtext = "Videobreite auf $VideoBreite angepasst (Seitenverhältnis: $OrgRatio)"; writeLog($logfile, $logtext);  }
    }

    // Die Werte für breite und Höhe müssen gerade Zahlen also durch 2 Teilbar sein wenn nicht, dann 1 Pixel abziehen
    if ($VideoBreite % 2 != 0) {$Videobreite = $VideoBreite-1; $logtext = "Videobreite auf $VideoBreite angepasst (gerade Zahl)"; writeLog($logfile, $logtext); }
    if ($VideoHoehe % 2 != 0) {$VideoHoehe = $VideoHoehe-1; $logtext = "Videohöhe auf $VideoHoehe angepasst (gerade Zahl)"; writeLog($logfile, $logtext);}

    // Kontrolle ob die berechneten Werte die maximalen Grenzen überschrieten
    // Breite und Höhe des gewünschten Videos dürfen die maximale Auflösung nicht überschreiten oder kleiner 0 sein
    if ($VideoBreite > $MaxResolutionX) { $abbruch = true; $logtext = "Videobreite überschreitet maximal zulässigen Wert ($MaxResolutionX): $VideoBreite";   writeLog($logfile, $logtext);  }

    // Breite und Höhe des gewünschten Videos dürfen die maximale Auflösung nicht überschreiten oder kleiner 0 sein
    if ($VideoHoehe > $MaxResolutionY) { $abbruch = true; $logtext = "Videohöhe überschreitet maximal zulässigen Wert ($MaxResolutionY): $VideoHoehe";   writeLog($logfile, $logtext);  }

    // erneut auf Abbruch Prüfen, nach Berechnung der neuen Video Werte
    if ($abbruch == false) { 

        // Name der Ausgabedatei

        If ($MCVideo == true) { $vext =".mpeg"; } else { $vext =".mp4"; }
        $OutputFile = "Work_in_Progress_".$BildDIR."_".$VideoBreite."x".$VideoHoehe.$vext;
        $OutputFileFinal = $BildDIR."_".$VideoBreite."x".$VideoHoehe.$vext;
        $logtext = "Name der Ausgabedatei: $OutputFile";      writeLog($logfile, $logtext); 

        // Prüfen ob Datei existiert und gegebenenfalls vorher umbennen
        $Checkfile = $StarCatcherVideoDir.$OutputFile;
        if (file_exists($Checkfile)) {
            $RenameTo = date("Ymd_His"); 
            $RenameName = $BildDIR."_".$VideoBreite."x".$VideoHoehe."_".$RenameTo.".mp4";
            $newFileRenamed=$StarCatcherVideoDir.$RenameName;
            rename($Checkfile, $newFileRenamed);
            $logtext = "Video $Checkfile umbenannt in $newFileRenamed";   
            writeLog($logfile, $logtext); 
        }

        If ($MCVideo == true) {

            $shellcmd = "cd $BildSRC &&  mencoder \"mf://*.$FileEx\" -mf w=$origWidth:h=$origHeight:fps=$hz:type=$FileEx -ovc lavc -lavcopts vcodec=mpeg4:mbd=2:trell:v4mv:autoaspect:vbitrate=7000 -vf scale=$VideoBreite:$VideoHoehe -nosound -o $StarCatcherVideoDir$OutputFile";
            $logtext = "Erstellter Befehl für die Videoerstellung: ".$shellcmd ;     writeLog($logfile, $logtext); 

            // Den Job starten
            $logtext = "MENCODER Zur Videoerstellung gestartet";      writeLog($logfile, $logtext); 
            $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);
            $logtext = "Video :".$BildSRC.$BildDIR.".mp4 erstellt.";    writeLog($logfile, $logtext);             
        }
        else {
            // ffmpeg -r 25 -pattern_type glob -i '/home/liebhoff/StarCatcher/Bilder/20240302/*.jpg' -c:v libx264 -b:v 7000K -pix_fmt yuv420p -movflags +faststart -filter:v scale=2882:2160 /home/liebhoff/StarCatcher/Video/20240302_test02.mp4

            $shellcmd = "ffmpeg -pattern_type glob -i '$BildSRC*.$FileEx' -c:v $ViCodec -r $hz -b:v $BITRate -pix_fmt $PIXFMT -movflags +faststart -filter:v scale=$VideoBreite:$VideoHoehe $StarCatcherVideoDir$OutputFile";
            $logtext = "Erstellter Befehl für die Videoerstellung: ".$shellcmd ;     writeLog($logfile, $logtext); 

            // Den Job starten
            $logtext = "FFMPEG Zur Videoerstellung gestartet";      writeLog($logfile, $logtext); 
            $ergebnis=null; $retval=null; exec($shellcmd, $ergebnis, $retval);
            $logtext = "Video :".$BildSRC.$BildDIR.".mp4 erstellt.";    writeLog($logfile, $logtext); 
        }
    
        // wenn Datei erstellt, auf finalen Namen umbenennen 
        rename($StarCatcherVideoDir.$OutputFile, $StarCatcherVideoDir.$OutputFileFinal);
        $logtext = "Video $OutputFile umbenannt in $OutputFileFinal - Datei erstellt";   writeLog($logfile, $logtext); 
    }
    
}

else {
    $logtext = "Parameterdatei nicht übergeben, falsch oder unvollständig, keine Verarbeitung möglich!";
    writeLog($logfile, $logtext);
}

//Parameter Datei löschen, da Video erstellt
$dltFile = $wwwpfad.$parameterdatei;
unlink($dltFile);
$logtext = "Parameterdatei $parameterdatei gelöscht da Video erstellt oder Verarbeitungsfehler.";        writeLog($logfile, $logtext); 

// Dieser Job kann lange dauern, daher muss das Time Limit für die Ausführung von PHP Scripten erhöht werden (Std 30 Sec)
//Zurück auf Standard 30 Sekunden
ini_set('max_execution_time', '30'); 